diff --git a/debian/changelog b/debian/changelog
index 7712e5e..c015a71 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -1,3 +1,9 @@
+base-installer (1.129) UNRELEASED; urgency=low
+
+  * Properly recognize PowerPC SMP machines. Closes: #629492
+
+ -- Milan Kupcevic <milan@physics.harvard.edu>  Tue, 06 Nov 2012 11:21:07 -0500
+
 base-installer (1.128) unstable; urgency=low
 
   * Add support for armhf/vexpress.
diff --git a/kernel/powerpc.sh b/kernel/powerpc.sh
index d8f09d0..b2b9b93 100644
--- a/kernel/powerpc.sh
+++ b/kernel/powerpc.sh
@@ -29,7 +29,7 @@ arch_check_usable_kernel () {
 }
 
 arch_get_kernel () {
-	CPUS="$(grep -ci ^processor "$CPUINFO")" || CPUS=1
+	CPUS="$(ls /proc/device-tree/cpus/ | grep -ci @[0-9])" || CPUS=1
 	if [ "$CPUS" ] && [ "$CPUS" -gt 1 ] && \
 	   [ "$1" != "powerpc64" ] && [ "$1" != "prep" ] ; then
 		SMP=-smp
